// third_party/blink/public/mojom/reporting/reporting.mojom.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#endif

#include "third_party/blink/public/mojom/reporting/reporting.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/hash/md5_constexpr.h"
#include "base/run_loop.h"
#include "base/strings/string_number_conversions.h"
#include "base/task/common/task_annotator.h"
#include "base/trace_event/trace_conversion_helper.h"
#include "base/trace_event/traced_value.h"
#include "mojo/public/cpp/bindings/lib/generated_code_util.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"

#include "third_party/blink/public/mojom/reporting/reporting.mojom-params-data.h"
#include "third_party/blink/public/mojom/reporting/reporting.mojom-shared-message-ids.h"

#include "third_party/blink/public/mojom/reporting/reporting.mojom-import-headers.h"


#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_REPORTING_REPORTING_MOJOM_JUMBO_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_REPORTING_REPORTING_MOJOM_JUMBO_H_
#endif
namespace blink {
namespace mojom {
const char ReportingServiceProxy::Name_[] = "blink.mojom.ReportingServiceProxy";

ReportingServiceProxyProxy::ReportingServiceProxyProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void ReportingServiceProxyProxy::QueueInterventionReport(
    const ::GURL& in_url, const std::string& in_id, const std::string& in_message, const base::Optional<std::string>& in_source_file, int32_t in_line_number, int32_t in_column_number) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1(
    "mojom", "blink::mojom::ReportingServiceProxy::QueueInterventionReport", "input_parameters",
    [&](){
      auto value = std::make_unique<base::trace_event::TracedValue>();
      base::trace_event::TracedValue* raw_value = value.get();
      raw_value->SetString("url", base::trace_event::ValueToString(in_url, "<value of type const ::GURL&>"));
      raw_value->SetString("id", in_id);
      raw_value->SetString("message", in_message);
      if (in_source_file.has_value()) {
        raw_value->SetString("source_file", in_source_file.value());
      } else {
        raw_value->SetString("source_file", "base::nullopt");
      }
      raw_value->SetInteger("line_number", in_line_number);
      raw_value->SetInteger("column_number", in_column_number);
      return value;
    }());
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kReportingServiceProxy_QueueInterventionReport_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::blink::mojom::internal::ReportingServiceProxy_QueueInterventionReport_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->url)::BaseType::BufferWriter
      url_writer;
  mojo::internal::Serialize<::url::mojom::UrlDataView>(
      in_url, buffer, &url_writer, &serialization_context);
  params->url.Set(
      url_writer.is_null() ? nullptr : url_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->url.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null url in ReportingServiceProxy.QueueInterventionReport request");
  typename decltype(params->id)::BaseType::BufferWriter
      id_writer;
  mojo::internal::Serialize<mojo::StringDataView>(
      in_id, buffer, &id_writer, &serialization_context);
  params->id.Set(
      id_writer.is_null() ? nullptr : id_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->id.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null id in ReportingServiceProxy.QueueInterventionReport request");
  typename decltype(params->message)::BaseType::BufferWriter
      message_writer;
  mojo::internal::Serialize<mojo::StringDataView>(
      in_message, buffer, &message_writer, &serialization_context);
  params->message.Set(
      message_writer.is_null() ? nullptr : message_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->message.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null message in ReportingServiceProxy.QueueInterventionReport request");
  typename decltype(params->source_file)::BaseType::BufferWriter
      source_file_writer;
  mojo::internal::Serialize<mojo::StringDataView>(
      in_source_file, buffer, &source_file_writer, &serialization_context);
  params->source_file.Set(
      source_file_writer.is_null() ? nullptr : source_file_writer.data());
  params->line_number = in_line_number;
  params->column_number = in_column_number;
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(ReportingServiceProxy::Name_);
  message.set_method_name("QueueInterventionReport");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void ReportingServiceProxyProxy::QueueDeprecationReport(
    const ::GURL& in_url, const std::string& in_id, base::Optional<::base::Time> in_anticipatedRemoval, const std::string& in_message, const base::Optional<std::string>& in_source_file, int32_t in_line_number, int32_t in_column_number) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1(
    "mojom", "blink::mojom::ReportingServiceProxy::QueueDeprecationReport", "input_parameters",
    [&](){
      auto value = std::make_unique<base::trace_event::TracedValue>();
      base::trace_event::TracedValue* raw_value = value.get();
      raw_value->SetString("url", base::trace_event::ValueToString(in_url, "<value of type const ::GURL&>"));
      raw_value->SetString("id", in_id);
      raw_value->SetString("anticipatedRemoval", base::trace_event::ValueToString(in_anticipatedRemoval, "<value of type base::Optional<::base::Time>>"));
      raw_value->SetString("message", in_message);
      if (in_source_file.has_value()) {
        raw_value->SetString("source_file", in_source_file.value());
      } else {
        raw_value->SetString("source_file", "base::nullopt");
      }
      raw_value->SetInteger("line_number", in_line_number);
      raw_value->SetInteger("column_number", in_column_number);
      return value;
    }());
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kReportingServiceProxy_QueueDeprecationReport_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::blink::mojom::internal::ReportingServiceProxy_QueueDeprecationReport_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->url)::BaseType::BufferWriter
      url_writer;
  mojo::internal::Serialize<::url::mojom::UrlDataView>(
      in_url, buffer, &url_writer, &serialization_context);
  params->url.Set(
      url_writer.is_null() ? nullptr : url_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->url.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null url in ReportingServiceProxy.QueueDeprecationReport request");
  typename decltype(params->id)::BaseType::BufferWriter
      id_writer;
  mojo::internal::Serialize<mojo::StringDataView>(
      in_id, buffer, &id_writer, &serialization_context);
  params->id.Set(
      id_writer.is_null() ? nullptr : id_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->id.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null id in ReportingServiceProxy.QueueDeprecationReport request");
  typename decltype(params->anticipatedRemoval)::BaseType::BufferWriter
      anticipatedRemoval_writer;
  mojo::internal::Serialize<::mojo_base::mojom::TimeDataView>(
      in_anticipatedRemoval, buffer, &anticipatedRemoval_writer, &serialization_context);
  params->anticipatedRemoval.Set(
      anticipatedRemoval_writer.is_null() ? nullptr : anticipatedRemoval_writer.data());
  typename decltype(params->message)::BaseType::BufferWriter
      message_writer;
  mojo::internal::Serialize<mojo::StringDataView>(
      in_message, buffer, &message_writer, &serialization_context);
  params->message.Set(
      message_writer.is_null() ? nullptr : message_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->message.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null message in ReportingServiceProxy.QueueDeprecationReport request");
  typename decltype(params->source_file)::BaseType::BufferWriter
      source_file_writer;
  mojo::internal::Serialize<mojo::StringDataView>(
      in_source_file, buffer, &source_file_writer, &serialization_context);
  params->source_file.Set(
      source_file_writer.is_null() ? nullptr : source_file_writer.data());
  params->line_number = in_line_number;
  params->column_number = in_column_number;
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(ReportingServiceProxy::Name_);
  message.set_method_name("QueueDeprecationReport");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void ReportingServiceProxyProxy::QueueCspViolationReport(
    const ::GURL& in_url, const std::string& in_group, const std::string& in_document_url, const base::Optional<std::string>& in_referrer, const base::Optional<std::string>& in_blocked_url, const std::string& in_effective_directive, const std::string& in_original_policy, const base::Optional<std::string>& in_source_file, const base::Optional<std::string>& in_script_sample, const std::string& in_disposition, uint16_t in_status_code, int32_t in_line_number, int32_t in_column_number) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1(
    "mojom", "blink::mojom::ReportingServiceProxy::QueueCspViolationReport", "input_parameters",
    [&](){
      auto value = std::make_unique<base::trace_event::TracedValue>();
      base::trace_event::TracedValue* raw_value = value.get();
      raw_value->SetString("url", base::trace_event::ValueToString(in_url, "<value of type const ::GURL&>"));
      raw_value->SetString("group", in_group);
      raw_value->SetString("document_url", in_document_url);
      if (in_referrer.has_value()) {
        raw_value->SetString("referrer", in_referrer.value());
      } else {
        raw_value->SetString("referrer", "base::nullopt");
      }
      if (in_blocked_url.has_value()) {
        raw_value->SetString("blocked_url", in_blocked_url.value());
      } else {
        raw_value->SetString("blocked_url", "base::nullopt");
      }
      raw_value->SetString("effective_directive", in_effective_directive);
      raw_value->SetString("original_policy", in_original_policy);
      if (in_source_file.has_value()) {
        raw_value->SetString("source_file", in_source_file.value());
      } else {
        raw_value->SetString("source_file", "base::nullopt");
      }
      if (in_script_sample.has_value()) {
        raw_value->SetString("script_sample", in_script_sample.value());
      } else {
        raw_value->SetString("script_sample", "base::nullopt");
      }
      raw_value->SetString("disposition", in_disposition);
      raw_value->SetInteger("status_code", in_status_code);
      raw_value->SetInteger("line_number", in_line_number);
      raw_value->SetInteger("column_number", in_column_number);
      return value;
    }());
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kReportingServiceProxy_QueueCspViolationReport_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::blink::mojom::internal::ReportingServiceProxy_QueueCspViolationReport_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->url)::BaseType::BufferWriter
      url_writer;
  mojo::internal::Serialize<::url::mojom::UrlDataView>(
      in_url, buffer, &url_writer, &serialization_context);
  params->url.Set(
      url_writer.is_null() ? nullptr : url_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->url.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null url in ReportingServiceProxy.QueueCspViolationReport request");
  typename decltype(params->group)::BaseType::BufferWriter
      group_writer;
  mojo::internal::Serialize<mojo::StringDataView>(
      in_group, buffer, &group_writer, &serialization_context);
  params->group.Set(
      group_writer.is_null() ? nullptr : group_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->group.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null group in ReportingServiceProxy.QueueCspViolationReport request");
  typename decltype(params->document_url)::BaseType::BufferWriter
      document_url_writer;
  mojo::internal::Serialize<mojo::StringDataView>(
      in_document_url, buffer, &document_url_writer, &serialization_context);
  params->document_url.Set(
      document_url_writer.is_null() ? nullptr : document_url_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->document_url.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null document_url in ReportingServiceProxy.QueueCspViolationReport request");
  typename decltype(params->referrer)::BaseType::BufferWriter
      referrer_writer;
  mojo::internal::Serialize<mojo::StringDataView>(
      in_referrer, buffer, &referrer_writer, &serialization_context);
  params->referrer.Set(
      referrer_writer.is_null() ? nullptr : referrer_writer.data());
  typename decltype(params->blocked_url)::BaseType::BufferWriter
      blocked_url_writer;
  mojo::internal::Serialize<mojo::StringDataView>(
      in_blocked_url, buffer, &blocked_url_writer, &serialization_context);
  params->blocked_url.Set(
      blocked_url_writer.is_null() ? nullptr : blocked_url_writer.data());
  typename decltype(params->effective_directive)::BaseType::BufferWriter
      effective_directive_writer;
  mojo::internal::Serialize<mojo::StringDataView>(
      in_effective_directive, buffer, &effective_directive_writer, &serialization_context);
  params->effective_directive.Set(
      effective_directive_writer.is_null() ? nullptr : effective_directive_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->effective_directive.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null effective_directive in ReportingServiceProxy.QueueCspViolationReport request");
  typename decltype(params->original_policy)::BaseType::BufferWriter
      original_policy_writer;
  mojo::internal::Serialize<mojo::StringDataView>(
      in_original_policy, buffer, &original_policy_writer, &serialization_context);
  params->original_policy.Set(
      original_policy_writer.is_null() ? nullptr : original_policy_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->original_policy.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null original_policy in ReportingServiceProxy.QueueCspViolationReport request");
  typename decltype(params->source_file)::BaseType::BufferWriter
      source_file_writer;
  mojo::internal::Serialize<mojo::StringDataView>(
      in_source_file, buffer, &source_file_writer, &serialization_context);
  params->source_file.Set(
      source_file_writer.is_null() ? nullptr : source_file_writer.data());
  typename decltype(params->script_sample)::BaseType::BufferWriter
      script_sample_writer;
  mojo::internal::Serialize<mojo::StringDataView>(
      in_script_sample, buffer, &script_sample_writer, &serialization_context);
  params->script_sample.Set(
      script_sample_writer.is_null() ? nullptr : script_sample_writer.data());
  typename decltype(params->disposition)::BaseType::BufferWriter
      disposition_writer;
  mojo::internal::Serialize<mojo::StringDataView>(
      in_disposition, buffer, &disposition_writer, &serialization_context);
  params->disposition.Set(
      disposition_writer.is_null() ? nullptr : disposition_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->disposition.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null disposition in ReportingServiceProxy.QueueCspViolationReport request");
  params->status_code = in_status_code;
  params->line_number = in_line_number;
  params->column_number = in_column_number;
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(ReportingServiceProxy::Name_);
  message.set_method_name("QueueCspViolationReport");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void ReportingServiceProxyProxy::QueueFeaturePolicyViolationReport(
    const ::GURL& in_url, const std::string& in_policy_id, const std::string& in_disposition, const base::Optional<std::string>& in_message, const base::Optional<std::string>& in_source_file, int32_t in_line_number, int32_t in_column_number) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1(
    "mojom", "blink::mojom::ReportingServiceProxy::QueueFeaturePolicyViolationReport", "input_parameters",
    [&](){
      auto value = std::make_unique<base::trace_event::TracedValue>();
      base::trace_event::TracedValue* raw_value = value.get();
      raw_value->SetString("url", base::trace_event::ValueToString(in_url, "<value of type const ::GURL&>"));
      raw_value->SetString("policy_id", in_policy_id);
      raw_value->SetString("disposition", in_disposition);
      if (in_message.has_value()) {
        raw_value->SetString("message", in_message.value());
      } else {
        raw_value->SetString("message", "base::nullopt");
      }
      if (in_source_file.has_value()) {
        raw_value->SetString("source_file", in_source_file.value());
      } else {
        raw_value->SetString("source_file", "base::nullopt");
      }
      raw_value->SetInteger("line_number", in_line_number);
      raw_value->SetInteger("column_number", in_column_number);
      return value;
    }());
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kReportingServiceProxy_QueueFeaturePolicyViolationReport_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::blink::mojom::internal::ReportingServiceProxy_QueueFeaturePolicyViolationReport_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->url)::BaseType::BufferWriter
      url_writer;
  mojo::internal::Serialize<::url::mojom::UrlDataView>(
      in_url, buffer, &url_writer, &serialization_context);
  params->url.Set(
      url_writer.is_null() ? nullptr : url_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->url.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null url in ReportingServiceProxy.QueueFeaturePolicyViolationReport request");
  typename decltype(params->policy_id)::BaseType::BufferWriter
      policy_id_writer;
  mojo::internal::Serialize<mojo::StringDataView>(
      in_policy_id, buffer, &policy_id_writer, &serialization_context);
  params->policy_id.Set(
      policy_id_writer.is_null() ? nullptr : policy_id_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->policy_id.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null policy_id in ReportingServiceProxy.QueueFeaturePolicyViolationReport request");
  typename decltype(params->disposition)::BaseType::BufferWriter
      disposition_writer;
  mojo::internal::Serialize<mojo::StringDataView>(
      in_disposition, buffer, &disposition_writer, &serialization_context);
  params->disposition.Set(
      disposition_writer.is_null() ? nullptr : disposition_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->disposition.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null disposition in ReportingServiceProxy.QueueFeaturePolicyViolationReport request");
  typename decltype(params->message)::BaseType::BufferWriter
      message_writer;
  mojo::internal::Serialize<mojo::StringDataView>(
      in_message, buffer, &message_writer, &serialization_context);
  params->message.Set(
      message_writer.is_null() ? nullptr : message_writer.data());
  typename decltype(params->source_file)::BaseType::BufferWriter
      source_file_writer;
  mojo::internal::Serialize<mojo::StringDataView>(
      in_source_file, buffer, &source_file_writer, &serialization_context);
  params->source_file.Set(
      source_file_writer.is_null() ? nullptr : source_file_writer.data());
  params->line_number = in_line_number;
  params->column_number = in_column_number;
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(ReportingServiceProxy::Name_);
  message.set_method_name("QueueFeaturePolicyViolationReport");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void ReportingServiceProxyProxy::QueueDocumentPolicyViolationReport(
    const ::GURL& in_url, const std::string& in_group, const std::string& in_policy_id, const std::string& in_disposition, const base::Optional<std::string>& in_message, const base::Optional<std::string>& in_source_file, int32_t in_line_number, int32_t in_column_number) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1(
    "mojom", "blink::mojom::ReportingServiceProxy::QueueDocumentPolicyViolationReport", "input_parameters",
    [&](){
      auto value = std::make_unique<base::trace_event::TracedValue>();
      base::trace_event::TracedValue* raw_value = value.get();
      raw_value->SetString("url", base::trace_event::ValueToString(in_url, "<value of type const ::GURL&>"));
      raw_value->SetString("group", in_group);
      raw_value->SetString("policy_id", in_policy_id);
      raw_value->SetString("disposition", in_disposition);
      if (in_message.has_value()) {
        raw_value->SetString("message", in_message.value());
      } else {
        raw_value->SetString("message", "base::nullopt");
      }
      if (in_source_file.has_value()) {
        raw_value->SetString("source_file", in_source_file.value());
      } else {
        raw_value->SetString("source_file", "base::nullopt");
      }
      raw_value->SetInteger("line_number", in_line_number);
      raw_value->SetInteger("column_number", in_column_number);
      return value;
    }());
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kReportingServiceProxy_QueueDocumentPolicyViolationReport_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::blink::mojom::internal::ReportingServiceProxy_QueueDocumentPolicyViolationReport_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->url)::BaseType::BufferWriter
      url_writer;
  mojo::internal::Serialize<::url::mojom::UrlDataView>(
      in_url, buffer, &url_writer, &serialization_context);
  params->url.Set(
      url_writer.is_null() ? nullptr : url_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->url.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null url in ReportingServiceProxy.QueueDocumentPolicyViolationReport request");
  typename decltype(params->group)::BaseType::BufferWriter
      group_writer;
  mojo::internal::Serialize<mojo::StringDataView>(
      in_group, buffer, &group_writer, &serialization_context);
  params->group.Set(
      group_writer.is_null() ? nullptr : group_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->group.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null group in ReportingServiceProxy.QueueDocumentPolicyViolationReport request");
  typename decltype(params->policy_id)::BaseType::BufferWriter
      policy_id_writer;
  mojo::internal::Serialize<mojo::StringDataView>(
      in_policy_id, buffer, &policy_id_writer, &serialization_context);
  params->policy_id.Set(
      policy_id_writer.is_null() ? nullptr : policy_id_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->policy_id.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null policy_id in ReportingServiceProxy.QueueDocumentPolicyViolationReport request");
  typename decltype(params->disposition)::BaseType::BufferWriter
      disposition_writer;
  mojo::internal::Serialize<mojo::StringDataView>(
      in_disposition, buffer, &disposition_writer, &serialization_context);
  params->disposition.Set(
      disposition_writer.is_null() ? nullptr : disposition_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->disposition.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null disposition in ReportingServiceProxy.QueueDocumentPolicyViolationReport request");
  typename decltype(params->message)::BaseType::BufferWriter
      message_writer;
  mojo::internal::Serialize<mojo::StringDataView>(
      in_message, buffer, &message_writer, &serialization_context);
  params->message.Set(
      message_writer.is_null() ? nullptr : message_writer.data());
  typename decltype(params->source_file)::BaseType::BufferWriter
      source_file_writer;
  mojo::internal::Serialize<mojo::StringDataView>(
      in_source_file, buffer, &source_file_writer, &serialization_context);
  params->source_file.Set(
      source_file_writer.is_null() ? nullptr : source_file_writer.data());
  params->line_number = in_line_number;
  params->column_number = in_column_number;
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(ReportingServiceProxy::Name_);
  message.set_method_name("QueueDocumentPolicyViolationReport");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

// static
bool ReportingServiceProxyStubDispatch::Accept(
    ReportingServiceProxy* impl,
    mojo::Message* message) {
  mojo::internal::MessageDispatchContext dispatch_context(message);
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  switch (message->header()->name) {
    case internal::kReportingServiceProxy_QueueInterventionReport_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)blink::mojom::ReportingServiceProxy::QueueInterventionReport",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)blink::mojom::ReportingServiceProxy::QueueInterventionReport");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);

      DCHECK(message->is_serialized());
      internal::ReportingServiceProxy_QueueInterventionReport_Params_Data* params =
          reinterpret_cast<internal::ReportingServiceProxy_QueueInterventionReport_Params_Data*>(
              message->mutable_payload());
      
      bool success = true;
      ::GURL p_url{};
      std::string p_id{};
      std::string p_message{};
      base::Optional<std::string> p_source_file{};
      int32_t p_line_number{};
      int32_t p_column_number{};
      ReportingServiceProxy_QueueInterventionReport_ParamsDataView input_data_view(params, &serialization_context);
      
      if (success && !input_data_view.ReadUrl(&p_url))
        success = false;
      if (success && !input_data_view.ReadId(&p_id))
        success = false;
      if (success && !input_data_view.ReadMessage(&p_message))
        success = false;
      if (success && !input_data_view.ReadSourceFile(&p_source_file))
        success = false;
      if (success)
        p_line_number = input_data_view.line_number();
      if (success)
        p_column_number = input_data_view.column_number();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            ReportingServiceProxy::Name_, 0, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->QueueInterventionReport(
std::move(p_url), 
std::move(p_id), 
std::move(p_message), 
std::move(p_source_file), 
std::move(p_line_number), 
std::move(p_column_number));
      return true;
    }
    case internal::kReportingServiceProxy_QueueDeprecationReport_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)blink::mojom::ReportingServiceProxy::QueueDeprecationReport",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)blink::mojom::ReportingServiceProxy::QueueDeprecationReport");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);

      DCHECK(message->is_serialized());
      internal::ReportingServiceProxy_QueueDeprecationReport_Params_Data* params =
          reinterpret_cast<internal::ReportingServiceProxy_QueueDeprecationReport_Params_Data*>(
              message->mutable_payload());
      
      bool success = true;
      ::GURL p_url{};
      std::string p_id{};
      base::Optional<::base::Time> p_anticipatedRemoval{};
      std::string p_message{};
      base::Optional<std::string> p_source_file{};
      int32_t p_line_number{};
      int32_t p_column_number{};
      ReportingServiceProxy_QueueDeprecationReport_ParamsDataView input_data_view(params, &serialization_context);
      
      if (success && !input_data_view.ReadUrl(&p_url))
        success = false;
      if (success && !input_data_view.ReadId(&p_id))
        success = false;
      if (success && !input_data_view.ReadAnticipatedRemoval(&p_anticipatedRemoval))
        success = false;
      if (success && !input_data_view.ReadMessage(&p_message))
        success = false;
      if (success && !input_data_view.ReadSourceFile(&p_source_file))
        success = false;
      if (success)
        p_line_number = input_data_view.line_number();
      if (success)
        p_column_number = input_data_view.column_number();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            ReportingServiceProxy::Name_, 1, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->QueueDeprecationReport(
std::move(p_url), 
std::move(p_id), 
std::move(p_anticipatedRemoval), 
std::move(p_message), 
std::move(p_source_file), 
std::move(p_line_number), 
std::move(p_column_number));
      return true;
    }
    case internal::kReportingServiceProxy_QueueCspViolationReport_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)blink::mojom::ReportingServiceProxy::QueueCspViolationReport",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)blink::mojom::ReportingServiceProxy::QueueCspViolationReport");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);

      DCHECK(message->is_serialized());
      internal::ReportingServiceProxy_QueueCspViolationReport_Params_Data* params =
          reinterpret_cast<internal::ReportingServiceProxy_QueueCspViolationReport_Params_Data*>(
              message->mutable_payload());
      
      bool success = true;
      ::GURL p_url{};
      std::string p_group{};
      std::string p_document_url{};
      base::Optional<std::string> p_referrer{};
      base::Optional<std::string> p_blocked_url{};
      std::string p_effective_directive{};
      std::string p_original_policy{};
      base::Optional<std::string> p_source_file{};
      base::Optional<std::string> p_script_sample{};
      std::string p_disposition{};
      uint16_t p_status_code{};
      int32_t p_line_number{};
      int32_t p_column_number{};
      ReportingServiceProxy_QueueCspViolationReport_ParamsDataView input_data_view(params, &serialization_context);
      
      if (success && !input_data_view.ReadUrl(&p_url))
        success = false;
      if (success && !input_data_view.ReadGroup(&p_group))
        success = false;
      if (success && !input_data_view.ReadDocumentUrl(&p_document_url))
        success = false;
      if (success && !input_data_view.ReadReferrer(&p_referrer))
        success = false;
      if (success && !input_data_view.ReadBlockedUrl(&p_blocked_url))
        success = false;
      if (success && !input_data_view.ReadEffectiveDirective(&p_effective_directive))
        success = false;
      if (success && !input_data_view.ReadOriginalPolicy(&p_original_policy))
        success = false;
      if (success && !input_data_view.ReadSourceFile(&p_source_file))
        success = false;
      if (success && !input_data_view.ReadScriptSample(&p_script_sample))
        success = false;
      if (success && !input_data_view.ReadDisposition(&p_disposition))
        success = false;
      if (success)
        p_status_code = input_data_view.status_code();
      if (success)
        p_line_number = input_data_view.line_number();
      if (success)
        p_column_number = input_data_view.column_number();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            ReportingServiceProxy::Name_, 2, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->QueueCspViolationReport(
std::move(p_url), 
std::move(p_group), 
std::move(p_document_url), 
std::move(p_referrer), 
std::move(p_blocked_url), 
std::move(p_effective_directive), 
std::move(p_original_policy), 
std::move(p_source_file), 
std::move(p_script_sample), 
std::move(p_disposition), 
std::move(p_status_code), 
std::move(p_line_number), 
std::move(p_column_number));
      return true;
    }
    case internal::kReportingServiceProxy_QueueFeaturePolicyViolationReport_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)blink::mojom::ReportingServiceProxy::QueueFeaturePolicyViolationReport",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)blink::mojom::ReportingServiceProxy::QueueFeaturePolicyViolationReport");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);

      DCHECK(message->is_serialized());
      internal::ReportingServiceProxy_QueueFeaturePolicyViolationReport_Params_Data* params =
          reinterpret_cast<internal::ReportingServiceProxy_QueueFeaturePolicyViolationReport_Params_Data*>(
              message->mutable_payload());
      
      bool success = true;
      ::GURL p_url{};
      std::string p_policy_id{};
      std::string p_disposition{};
      base::Optional<std::string> p_message{};
      base::Optional<std::string> p_source_file{};
      int32_t p_line_number{};
      int32_t p_column_number{};
      ReportingServiceProxy_QueueFeaturePolicyViolationReport_ParamsDataView input_data_view(params, &serialization_context);
      
      if (success && !input_data_view.ReadUrl(&p_url))
        success = false;
      if (success && !input_data_view.ReadPolicyId(&p_policy_id))
        success = false;
      if (success && !input_data_view.ReadDisposition(&p_disposition))
        success = false;
      if (success && !input_data_view.ReadMessage(&p_message))
        success = false;
      if (success && !input_data_view.ReadSourceFile(&p_source_file))
        success = false;
      if (success)
        p_line_number = input_data_view.line_number();
      if (success)
        p_column_number = input_data_view.column_number();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            ReportingServiceProxy::Name_, 3, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->QueueFeaturePolicyViolationReport(
std::move(p_url), 
std::move(p_policy_id), 
std::move(p_disposition), 
std::move(p_message), 
std::move(p_source_file), 
std::move(p_line_number), 
std::move(p_column_number));
      return true;
    }
    case internal::kReportingServiceProxy_QueueDocumentPolicyViolationReport_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)blink::mojom::ReportingServiceProxy::QueueDocumentPolicyViolationReport",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)blink::mojom::ReportingServiceProxy::QueueDocumentPolicyViolationReport");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);

      DCHECK(message->is_serialized());
      internal::ReportingServiceProxy_QueueDocumentPolicyViolationReport_Params_Data* params =
          reinterpret_cast<internal::ReportingServiceProxy_QueueDocumentPolicyViolationReport_Params_Data*>(
              message->mutable_payload());
      
      bool success = true;
      ::GURL p_url{};
      std::string p_group{};
      std::string p_policy_id{};
      std::string p_disposition{};
      base::Optional<std::string> p_message{};
      base::Optional<std::string> p_source_file{};
      int32_t p_line_number{};
      int32_t p_column_number{};
      ReportingServiceProxy_QueueDocumentPolicyViolationReport_ParamsDataView input_data_view(params, &serialization_context);
      
      if (success && !input_data_view.ReadUrl(&p_url))
        success = false;
      if (success && !input_data_view.ReadGroup(&p_group))
        success = false;
      if (success && !input_data_view.ReadPolicyId(&p_policy_id))
        success = false;
      if (success && !input_data_view.ReadDisposition(&p_disposition))
        success = false;
      if (success && !input_data_view.ReadMessage(&p_message))
        success = false;
      if (success && !input_data_view.ReadSourceFile(&p_source_file))
        success = false;
      if (success)
        p_line_number = input_data_view.line_number();
      if (success)
        p_column_number = input_data_view.column_number();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            ReportingServiceProxy::Name_, 4, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->QueueDocumentPolicyViolationReport(
std::move(p_url), 
std::move(p_group), 
std::move(p_policy_id), 
std::move(p_disposition), 
std::move(p_message), 
std::move(p_source_file), 
std::move(p_line_number), 
std::move(p_column_number));
      return true;
    }
  }
  return false;
}

// static
bool ReportingServiceProxyStubDispatch::AcceptWithResponder(
    ReportingServiceProxy* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  mojo::internal::MessageDispatchContext dispatch_context(message);
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  const bool message_is_sync = message->has_flag(mojo::Message::kFlagIsSync);
  const uint64_t request_id = message->request_id();
  ALLOW_UNUSED_LOCAL(message_is_sync);
  ALLOW_UNUSED_LOCAL(request_id);
  switch (message->header()->name) {
    case internal::kReportingServiceProxy_QueueInterventionReport_Name: {
      break;
    }
    case internal::kReportingServiceProxy_QueueDeprecationReport_Name: {
      break;
    }
    case internal::kReportingServiceProxy_QueueCspViolationReport_Name: {
      break;
    }
    case internal::kReportingServiceProxy_QueueFeaturePolicyViolationReport_Name: {
      break;
    }
    case internal::kReportingServiceProxy_QueueDocumentPolicyViolationReport_Name: {
      break;
    }
  }
  return false;
}


static const mojo::internal::GenericValidationInfo kReportingServiceProxyValidationInfo[] = {
    {&internal::ReportingServiceProxy_QueueInterventionReport_Params_Data::Validate,
     nullptr /* no response */},
    {&internal::ReportingServiceProxy_QueueDeprecationReport_Params_Data::Validate,
     nullptr /* no response */},
    {&internal::ReportingServiceProxy_QueueCspViolationReport_Params_Data::Validate,
     nullptr /* no response */},
    {&internal::ReportingServiceProxy_QueueFeaturePolicyViolationReport_Params_Data::Validate,
     nullptr /* no response */},
    {&internal::ReportingServiceProxy_QueueDocumentPolicyViolationReport_Params_Data::Validate,
     nullptr /* no response */},
};

bool ReportingServiceProxyRequestValidator::Accept(mojo::Message* message) {
  const char* name = ::blink::mojom::ReportingServiceProxy::Name_;
  return mojo::internal::ValidateRequestGenericPacked(message, name, kReportingServiceProxyValidationInfo);
}

}  // namespace mojom
}  // namespace blink

namespace mojo {

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#endif