// ui/accessibility/mojom/ax_event_intent.mojom-blink.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef UI_ACCESSIBILITY_MOJOM_AX_EVENT_INTENT_MOJOM_BLINK_H_
#define UI_ACCESSIBILITY_MOJOM_AX_EVENT_INTENT_MOJOM_BLINK_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "ui/accessibility/mojom/ax_event_intent.mojom-shared.h"
#include "ui/accessibility/mojom/ax_event_intent.mojom-blink-forward.h"
#include "ui/accessibility/ax_enums.mojom-blink-forward.h"

#include "mojo/public/cpp/bindings/lib/wtf_clone_equals_util.h"
#include "mojo/public/cpp/bindings/lib/wtf_hash_util.h"
#include "third_party/blink/renderer/platform/wtf/hash_functions.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"







// Forward-declare for |AsValueInto| so that we do not have to import the
// corresponding header.
namespace base {
namespace trace_event {
class TracedValue;
}  // namespace trace_event
}  // namespace base


namespace ax {
namespace mojom {
namespace blink {





class  EventIntent {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<EventIntent, T>::value>;
  using DataView = EventIntentDataView;
  using Data_ = internal::EventIntent_Data;

  template <typename... Args>
  static EventIntentPtr New(Args&&... args) {
    return EventIntentPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static EventIntentPtr From(const U& u) {
    return mojo::TypeConverter<EventIntentPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, EventIntent>::Convert(*this);
  }


  EventIntent();

  EventIntent(
      ::ax::mojom::blink::Command command,
      ::ax::mojom::blink::InputEventType input_event_type,
      ::ax::mojom::blink::TextBoundary text_boundary,
      ::ax::mojom::blink::MoveDirection move_direction);

  ~EventIntent();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = EventIntentPtr>
  EventIntentPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, EventIntent::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;
  size_t Hash(size_t seed) const;

  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        EventIntent::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        EventIntent::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::EventIntent_UnserializedMessageContext<
            UserType, EventIntent::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<EventIntent::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return EventIntent::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::EventIntent_UnserializedMessageContext<
            UserType, EventIntent::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<EventIntent::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  ::ax::mojom::blink::Command command;
  
  ::ax::mojom::blink::InputEventType input_event_type;
  
  ::ax::mojom::blink::TextBoundary text_boundary;
  
  ::ax::mojom::blink::MoveDirection move_direction;

  // Write this structure into |value|. The members are represented as a
  // dictionary |member name|: |member value|. This method does not deal with
  // the dictionary name. The caller is responsible for not calling
  // |AsValueInto| when |value| expects array items (see Array/Dictionary
  // methods of |base::trace_event::TracedValue|).
  //
  // |value| The TracedValue to be written into.
  //
  // Example uses:
  //
  //   // |my_var1, my_var2| are variables with defined |AsValueInto| method.
  //   auto value = std::make_unique<base::trace_event::TracedValue>();
  //   value->BeginDictionary("my_var1");
  //   my_var1.AsValueInto(value.get());
  //   value->EndDictionary();
  //   value->BeginDictionary("my_var2");
  //   my_var2.AsValueInto(value.get());
  //   value->EndDictionary();
  //
  //   // |my_var| is a variable with defined |AsValueInto| method.
  //   auto value = std::make_unique<base::trace_event::TracedValue>();
  //   my_var.AsValueInto(value.get());
  //   TRACE_EVENT1("test", "test", "my_var", std::move(value));
  //
  // Calling |AsValueInto| on two objects without opening and closing a
  // dictionary for each object is theoretically possible, but strongly
  // discouraged due to potential name collisions:
  //
  //   struct A {
  //     int foo;
  //   };
  //   struct B {
  //     int bar;
  //   };
  //   struct C {
  //     int foo;
  //     int bar;
  //   };
  //   auto value1 = std::make_unique<base::trace_event::TracedValue>();
  //   auto value2 = std::make_unique<base::trace_event::TracedValue>();
  //   A a;
  //   B b;
  //   C c;
  //   // value1 and value2 will be filled with the same information:
  //   a.AsValueInto(value1);
  //   b.AsValueInto(value1);
  //   c.AsValueInto(value2);
  void AsValueInto(base::trace_event::TracedValue* value) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, EventIntent::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, EventIntent::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, EventIntent::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, EventIntent::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}




template <typename StructPtrType>
EventIntentPtr EventIntent::Clone() const {
  return New(
      mojo::Clone(command),
      mojo::Clone(input_event_type),
      mojo::Clone(text_boundary),
      mojo::Clone(move_direction)
  );
}

template <typename T, EventIntent::EnableIfSame<T>*>
bool EventIntent::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->command, other_struct.command))
    return false;
  if (!mojo::Equals(this->input_event_type, other_struct.input_event_type))
    return false;
  if (!mojo::Equals(this->text_boundary, other_struct.text_boundary))
    return false;
  if (!mojo::Equals(this->move_direction, other_struct.move_direction))
    return false;
  return true;
}

template <typename T, EventIntent::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (std::less<>{}(lhs.command, rhs.command))
    return true;
  if (std::less<>{}(rhs.command, lhs.command))
    return false;
  if (std::less<>{}(lhs.input_event_type, rhs.input_event_type))
    return true;
  if (std::less<>{}(rhs.input_event_type, lhs.input_event_type))
    return false;
  if (std::less<>{}(lhs.text_boundary, rhs.text_boundary))
    return true;
  if (std::less<>{}(rhs.text_boundary, lhs.text_boundary))
    return false;
  if (std::less<>{}(lhs.move_direction, rhs.move_direction))
    return true;
  if (std::less<>{}(rhs.move_direction, lhs.move_direction))
    return false;
  return false;
}


}  // namespace blink
}  // namespace mojom
}  // namespace ax

namespace mojo {


template <>
struct  StructTraits<::ax::mojom::blink::EventIntent::DataView,
                                         ::ax::mojom::blink::EventIntentPtr> {
  static bool IsNull(const ::ax::mojom::blink::EventIntentPtr& input) { return !input; }
  static void SetToNull(::ax::mojom::blink::EventIntentPtr* output) { output->reset(); }

  static decltype(::ax::mojom::blink::EventIntent::command) command(
      const ::ax::mojom::blink::EventIntentPtr& input) {
    return input->command;
  }

  static decltype(::ax::mojom::blink::EventIntent::input_event_type) input_event_type(
      const ::ax::mojom::blink::EventIntentPtr& input) {
    return input->input_event_type;
  }

  static decltype(::ax::mojom::blink::EventIntent::text_boundary) text_boundary(
      const ::ax::mojom::blink::EventIntentPtr& input) {
    return input->text_boundary;
  }

  static decltype(::ax::mojom::blink::EventIntent::move_direction) move_direction(
      const ::ax::mojom::blink::EventIntentPtr& input) {
    return input->move_direction;
  }

  static bool Read(::ax::mojom::blink::EventIntent::DataView input, ::ax::mojom::blink::EventIntentPtr* output);
};

}  // namespace mojo

#endif  // UI_ACCESSIBILITY_MOJOM_AX_EVENT_INTENT_MOJOM_BLINK_H_